from datetime import datetime, timedelta
from .cron import rule_stat, seat_stat, score_stat, seat_time_stat
from django.http.response import JsonResponse
from dateutil.rrule import rrule, DAILY


# Create your views here.
def stat_rules_every(request):
    start_date = request.GET.get('start_date')
    end_date = request.GET.get('end_date')
    s_date = datetime.strptime(start_date, '%Y-%m-%d')
    e_date = datetime.strptime(end_date, '%Y-%m-%d')
    seed_dt = list(rrule(DAILY, byweekday=[0, 1, 2, 3, 4, 5, 6], dtstart=s_date, until=e_date))
    for date in seed_dt:
        date_str = date.strftime('%Y-%m-%d')
        rule_stat(date_str)
    return JsonResponse({'code': 0, 'msg': 'stat success'})


def stat_seats_every(request):
    start_date = request.GET.get('start_date')
    end_date = request.GET.get('end_date')
    s_date = datetime.strptime(start_date, '%Y-%m-%d')
    e_date = datetime.strptime(end_date, '%Y-%m-%d')
    seed_dt = list(rrule(DAILY, byweekday=[0, 1, 2, 3, 4, 5, 6], dtstart=s_date, until=e_date))
    for date in seed_dt:
        date_str = date.strftime('%Y-%m-%d')
        seat_stat(date_str)
    return JsonResponse({'code': 0, 'msg': 'stat success'})


def stat_scores_every(request):
    start_date = request.GET.get('start_date')
    end_date = request.GET.get('end_date')
    s_date = datetime.strptime(start_date, '%Y-%m-%d')
    e_date = datetime.strptime(end_date, '%Y-%m-%d')
    seed_dt = list(rrule(DAILY, byweekday=[0, 1, 2, 3, 4, 5, 6], dtstart=s_date, until=e_date))
    for date in seed_dt:
        date_str = date.strftime('%Y-%m-%d')
        score_stat(date_str)
    return JsonResponse({'code': 0, 'msg': 'stat success'})


def stat_time_every(request):
    start_date = request.GET.get('start_date')
    end_date = request.GET.get('end_date')
    s_date = datetime.strptime(start_date, '%Y-%m-%d')
    e_date = datetime.strptime(end_date, '%Y-%m-%d')
    seed_dt = list(rrule(DAILY, byweekday=[0, 1, 2, 3, 4, 5, 6], dtstart=s_date, until=e_date))
    for date in seed_dt:
        start_date = date.strftime('%Y-%m-%d')
        end_date = date.strftime('%Y-%m-%d') + ' 23:59:59'
        seat_time_stat(start_date, end_date)
    return JsonResponse({'code': 0, 'msg': 'stat success'})
